SystemOrganization addCategory: #'Orange-Resource'!

ALComponentResource subclass: #ORBasicAuthResource
	instanceVariableNames: 'caller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 16:09'!
authorized: result locator: aLocator
	| root cookie url |
	root := component rematerialize.
	"[root noteDispatch]
		on: ALUserStipulation
		do: [:stipulation | stipulation component user: result user]."
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	"^ ALResponse created
		location: 'http://www.abc.com';
		setCookie: cookie;
		yourself"
	^ (ALResponse seeOther: url)
			setCookie: cookie; 
			yourself! !

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:08'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 15:46'!
handleGet: aRequest locator: aLocator
	| request result authstring |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!ORBasicAuthResource methodsFor: 'as yet unclassified' stamp: 'chc 2/3/2015 16:15'!
respondWithChallenge
	^ALResponse unauthorized
		wwwAuthenticate: 'Basic Realm = "My Server"';
			yourself! !

ALHtmlResource subclass: #ORUploadResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORUploadResource commentStamp: 'chc 6/18/2015 08:36' prior: 0!
I think this one is to save data to a file on disk. #handlePut:locator:

Workspace notes:

	docroot := FSLocator imageDirectory.
	ALDirectoryScanner scan: docroot into: locator.
	docroot allEntries second basename

	stream := (FSLocator imageDirectory / 'package-cache' / 'fooforall.txt') writeStream.
	stream nextPutAll: 'Hello FooForAll'.
	stream close. 

Application notes:

	locator 
		at: ALPath root / 'source'
		put: (OPUploadResource component: OPDirectoryContents new)!

!ORUploadResource methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2015 15:58'!
handlePut: aRequest locator: aLocator
	| stream |
	" get the name from the request" 
	" place the name at the end of the FSLocator path" 
	" direct the 'stream contents' to the disk" 
	" done. I think" 
	aRequest readEntityWith: [ :in |  stream := (FSLocator imageDirectory / 'package-cache' / 'fooforall.txt') writeStream.
									stream nextPutAll: in.					
								      stream close. ].

	"isValidMczName: string
	^ string isString 
		and: [ string isEmpty not
			and: [ (string endsWith: '.mcz')
				and: [ (string includes: $/) not ] ] ]"

	"| name |
	name := request url allButFirst.
	((self isValidMczName: name) and: [ (self directory fileExists: name) not ]) 
		ifTrue: [
			self directory newFileNamed: name do: [ :file | | response |
				file binary.
				request streamFrom: request stream to: file size: request contentLength progress: nil.
				request sendCreated ] ]
		ifFalse: [ request sendBadRequest ]"

	! !

ALResource subclass: #ORAuthFormResource
	instanceVariableNames: 'resource form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORAuthFormResource class methodsFor: 'as yet unclassified' stamp: 'chc 4/13/2015 14:50'!
resource: aResource form: aForm
	^ self basicNew
		initializeWithResource: aResource form: aForm ! !

!ORAuthFormResource methodsFor: 'private' stamp: 'chc 4/13/2015 14:50'!
applyRequest: aRequest
	| data |
	data := aRequest readEntityWith: [ :in | ALFormDataParser parse: (in encoding: #ascii) ].
	form appyData: data.
	^ form process ifNil: [ resource ]! !

!ORAuthFormResource methodsFor: 'public' stamp: 'chc 4/22/2015 16:22'!
authorized: result locator: aLocator
	| root url |
	root := resource component rematerialize.
	root current: ALCounterExample new.
	"[root noteDispatch]
		on: ALUserStipulation
		do: [:stipulation | stipulation component user: result user]."
	url := aLocator urlForResource: root asResource.
"	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'."
	"^ ALResponse created
		location: 'http://www.abc.com';
		setCookie: cookie;
		yourself"
	^ "("ALResponse seeOther: url")
			setCookie: cookie; 
			yourself"! !

!ORAuthFormResource methodsFor: 'public' stamp: 'chc 6/17/2015 15:13'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!ORAuthFormResource methodsFor: 'private' stamp: 'chc 4/13/2015 14:50'!
handleData: data locator: aLocator
	| result url |
	form appyData: data.
	result := form process ifNil: [ resource ].
	url := aLocator urlForResource: result.
	^ ALResponse seeOther: url! !

!ORAuthFormResource methodsFor: 'public' stamp: 'chc 4/21/2015 16:30'!
handleGet: aRequest locator: aLocator
	| data request result |
	data := aRequest url query.
	request := ALAuthenticationRequest withUsername: (data at: 1) value password: (data at: 2) value.
	result := request signal.
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]! !

!ORAuthFormResource methodsFor: 'public' stamp: 'chc 4/13/2015 14:50'!
handlePost: aRequest locator: aLocator
	| data |
	data := aRequest readEntityWith: [ :in | ALFormDataParser parse: (in encoding: #ascii) ].
	^ self handleData: data locator: aLocator! !

!ORAuthFormResource methodsFor: 'initialization' stamp: 'chc 4/13/2015 14:50'!
initializeWithResource: aResource form: aForm
	self initialize.
	resource := aResource.
	form := aForm.! !

ALResource subclass: #ORAuthenticationResource
	instanceVariableNames: 'caller'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORAuthenticationResource class methodsFor: 'as yet unclassified' stamp: 'cwp 12/24/2012 08:25'!
component: aComponent
	^ self basicNew initializeWithComponent: aComponent! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 3/17/2015 14:51'!
authorized: result locator: aLocator
	| root cookie url |
	root := caller rematerialize.
	[root noteDispatch]
		on: ALUserStipulation
		do: [:stipulation | stipulation component auth: true ].
	url := aLocator urlForResource: root asResource.
	cookie := ALCookie name: 'auth' value: result token.
	cookie path: '/'.
	"^ ALResponse created
		location: 'http://localhost:8624' , url;
		setCookie: cookie;
		yourself"
	^ (ALResponse seeOther: url)
		setCookie: cookie;
		date: DateAndTime now;
		keepAlive: 'timeout=10, max=20';
		yourself! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 3/11/2015 14:17'!
denied
	^ ALResponse status: 401 reason: 'Authentication failed'! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 2/10/2015 15:35'!
handleGet: aRequest locator: aLocator
	| request result authstring |
	(aRequest authorization isNil)
		ifTrue: [^self respondWithChallenge]
		ifFalse: [
	authstring := (aRequest authorization copyAfter: Character space) base64Decoded.
	request := ALAuthenticationRequest withUsername:  (authstring copyUpTo: $:)   password: (authstring copyAfter: $:).
	result := request signal].
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]
			! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'chc 2/17/2015 16:30'!
handlePost: aRequest locator: aLocator
	| request result |
	request := ALAuthenticationRequest new.
	aRequest readEntityWith: 
		[:in | ALJsonParser  parse: in for: request].
	result := request signal.
	^ (result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [self denied]! !

!ORAuthenticationResource methodsFor: 'as yet unclassified' stamp: 'cwp 12/25/2012 11:40'!
initializeWithComponent: aComponent
	self initialize.
	caller := aComponent.
	! !

ALResource subclass: #ORUploadResource2
	instanceVariableNames: 'resource form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orange-Resource'!

!ORUploadResource2 commentStamp: 'chc 6/18/2015 08:37' prior: 0!
#handlePut:locator: is getting data from a request and feeding it to a form parser ALFormDataParser!

!ORUploadResource2 methodsFor: 'public' stamp: 'chc 5/19/2015 14:07'!
handleGet: aRequest locator: aLocator
	| data request result |
	data := aRequest url query.
	request := ALAuthenticationRequest withUsername: (data at: 1) value password: (data at: 2) value.
	result := request signal.
	^(result notNil and: [result isSuccess])
		ifTrue: [self authorized: result locator: aLocator]
		ifFalse: [ self denied ]! !

!ORUploadResource2 methodsFor: 'public' stamp: 'chc 5/19/2015 14:07'!
handlePost: aRequest locator: aLocator
	| data |
	data := aRequest readEntityWith: [ :in | ALFormDataParser parse: (in encoding: #ascii) ].
	^ self handleData: data locator: aLocator! !

!ORUploadResource2 methodsFor: 'public' stamp: 'chc 5/19/2015 14:48'!
handlePut: aRequest locator: aLocator
	| data |
	data := aRequest readEntityWith: [ :in | ALFormDataParser parse: (in encoding: #ascii) ].
	^ self handleData: data locator: aLocator.

	"isValidMczName: string
	^ string isString 
		and: [ string isEmpty not
			and: [ (string endsWith: '.mcz')
				and: [ (string includes: $/) not ] ] ]"

	"| name |
	name := request url allButFirst.
	((self isValidMczName: name) and: [ (self directory fileExists: name) not ]) 
		ifTrue: [
			self directory newFileNamed: name do: [ :file | | response |
				file binary.
				request streamFrom: request stream to: file size: request contentLength progress: nil.
				request sendCreated ] ]
		ifFalse: [ request sendBadRequest ]"

	"repositoryListing
	^ String streamContents: [ :str |
		str nextPutAll: '<html><head><title>'; nextPutAll: self realm; nextPutAll: '</title></head>'.
		str nextPutAll: '<body><h1>'; nextPutAll: self realm; nextPutAll: '</h1>'.
		str nextPutAll: '<ul>'.
		self mczEntries do: [ :each | 
			str nextPutAll: '<li><a href=""'; nextPutAll: each; nextPutAll: '"">'; nextPutAll: each; nextPutAll: '</a></li>'].
		str nextPutAll: '</ul></body></html>' ]"! !
